/*
Copyright (c) 2007,2007 Elizeu Nogueira da R. Jr.

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, 
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, 
      this list of conditions and the following disclaimer in the documentation 
      and/or other materials provided with the distribution.
    * Neither the name of the Elizeu Nogueira da R. Jr. nor the names of its 
      contributors may be used to endorse or promote products derived from this 
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package br.com.dreamsource.mobile.jmesql.io;

/**
 *
 * @author Elizeu Nogueira da Rosa Jr.
 * @version 0.1
 *
 */

import java.util.Enumeration;
import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotFoundException;
import javax.microedition.rms.RecordStoreNotOpenException;
import br.com.dreamsource.mobile.jmesql.exceptions.SQLException;

import java.util.Hashtable;

public class Properties extends Hashtable {
    
    /** Creates a new instance of Properties */
    
    private String FileName;
    
    private RecordStore RecStore;
    
    private String SEPARATOR = "}->{";
    
    private boolean isOpen;
    
    public Properties() {
    }
    
    public boolean checkFileExists() {
        try {
            RecStore = RecordStore.openRecordStore(this.FileName, false);
            RecStore.closeRecordStore();
            return true;
        }
        catch (RecordStoreNotFoundException rsnfe) {
            return false;
        }
        catch (Exception e) {
            return false;
        }
                
    }
    
    public void open() throws SQLException {
        try {
            RecStore = RecordStore.openRecordStore(this.FileName, true);
            RecordEnumeration RecEnum = RecStore.enumerateRecords(null, null, false);
            while (RecEnum.hasNextElement()) {
                String buff = new String(RecEnum.nextRecord());
                String Key = buff.substring(0, buff.indexOf(this.SEPARATOR));
                //int i = 
                StringBuffer Buff = new StringBuffer(buff);
                Buff.delete(0, buff.indexOf(this.SEPARATOR)+4);
                //String Value = buff.substring(buff.indexOf(this.SEPARATOR) + this.SEPARATOR.length(), buff.length());
                String Value = Buff.toString();
                put(Key, Value);
            }
            this.isOpen = true;
        }
        catch (RecordStoreException e) {
            new SQLException(e.getMessage());
        }
    }
    
    public void save() throws SQLException {
        try {
            Enumeration Enum = keys();
            if (this.checkFileExists()) {
                RecStore.closeRecordStore();
                //RecordStore.deleteRecordStore(this.FileName);
            }
            this.open();
            while (Enum.hasMoreElements()) {
                String key = (String)Enum.nextElement();
                String value = (String)get(key);
                String rec = key+this.SEPARATOR+value;
                RecStore.addRecord(rec.getBytes(), 0, rec.getBytes().length);
            }
        }
        catch (Exception e) {
            String Str = e.getMessage();
            throw new SQLException (e.getMessage());
        }
    }
    
    public void close() throws SQLException {
        try {
            if (this.isOpen) {
                RecStore.closeRecordStore();
                isOpen = false;
            }
        }
        catch (Exception e) {
            throw new SQLException(e.getMessage());
        }
    }
    
    public String getProperty(String key, String defaultValue) {
	String val = getProperty(key);
	return (val == null) ? defaultValue : val;
    }
    
    public String getProperty(String key) {
        if (containsKey(key)) {
            return (String)get(key);
        }
        else {
            return null;
        }
    }
    
    public Enumeration propertyNames() {
        return keys();
    }
    
    public void setProperty(String name, String value) {
        this.put(name, value);
    }
    
    public String getFileName() {
        return FileName;
    }

    public void setFileName(String FileName) {
        this.FileName = FileName;
    }

    public boolean isOpen() {
        return isOpen;
    }

}
