package br.com.dreamsource.mobile.worders;

import br.com.dreamsource.mobile.jmesql.exceptions.SQLException;
import br.com.dreamsource.mobile.jmesql.jdbcResultSet;
import br.com.dreamsource.mobile.worders.forms.MainMenu;
import br.com.dreamsource.mobile.worders.forms.core.Consts;
import br.com.dreamsource.mobile.worders.forms.core.DatabaseManager;
import br.com.dreamsource.mobile.worders.forms.core.Menu;
import br.com.dreamsource.mobile.worders.forms.core.SystemMessage;
import br.com.dreamsource.mobile.worders.forms.customer.Customer;
import br.com.dreamsource.mobile.worders.forms.customer.CustomerEdit;
import br.com.dreamsource.mobile.worders.forms.customer.CustomerList;
import br.com.dreamsource.mobile.worders.forms.product.Product;
import br.com.dreamsource.mobile.worders.forms.product.ProductList;
import br.com.dreamsource.mobile.worders.forms.user.ChangePassword;
import br.com.dreamsource.mobile.worders.forms.user.Login;
import br.com.dreamsource.mobile.worders.order.Order;
import br.com.dreamsource.mobile.worders.order.OrderList;
import br.com.dreamsource.mobile.worders.pojo.UserPOJO;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.midlet.MIDlet;

/**
 *
 * @author  Elizeu Nogueira da Rosa Jr.
 * @version 0.1
 * @date 15.05.2007
 *
 */

public class WOrders extends MIDlet implements javax.microedition.lcdui.CommandListener {
    
    private Menu menu;    
    
    private MainMenu mainMenu; 
    
    private SystemMessage systemMessage;
    
    private Customer customer;
    private CustomerList customerList;
    private CustomerEdit customerEdit;
    
    private Product product;
    private ProductList productList;
    
    private Order order;
    private OrderList orderList;
    
    private Login login;
    private ChangePassword changePassword;
    
    private UserPOJO userPOJO;
    
    public void startApp() {
        this.userPOJO = new UserPOJO();
        this.userPOJO.setConnectionURL(Consts.DATABASE_CONNETION_STRING);
        this.userPOJO.setDbName(Consts.DATABASE_NAME);
        if (DatabaseManager.databaseExists(Consts.DATABASE_NAME)) {
            Display.getDisplay(this).setCurrent(this.getLogin(Login.LOGIN_TYPE_SYSTEM_LOGIN));
        } else {
            Display.getDisplay(this).setCurrent(this.getLogin(Login.LOGIN_TYPE_CREATE_DATABASE));
        }
    }
    
    public void returnCreateDatabase(String userName, String passwd) {
        this.userPOJO = new UserPOJO();
        this.userPOJO.setConnectionURL(Consts.DATABASE_CONNETION_STRING);
        this.userPOJO.setDbName(Consts.DATABASE_NAME);
        this.userPOJO.setUserName(userName);
        this.userPOJO.setPasswd(passwd);
        try {
            DatabaseManager.createDatabase(userPOJO);
            Display.getDisplay(this).setCurrent(
                    this.getSystemMessage("Informaao", "Sistema inicializado com sucesso!", this.getMenu()));
        } catch (SQLException sqlEx) {
            Display.getDisplay(this).setCurrent(this.getSystemMessage("ERRO", sqlEx.getMessage(), null));
        }
        
    }
    
    public UserPOJO getUserPOJO() {
        return this.userPOJO;
    }
    
    public void serUserPOJO(UserPOJO value) {
        this.userPOJO = value;
    }
    
    public Menu getMenu() {
        menu = new Menu(this, this);
        return menu;
    }
    
    public MainMenu getMainMenu() {
        mainMenu = new MainMenu(this, this);
        return mainMenu;
    }
    
    public SystemMessage getSystemMessage(String title, String errorMessage, Form backForm) {
        systemMessage = new SystemMessage(this, this, title, errorMessage, backForm);
        return systemMessage;
    }

    public Customer getCustomer() {
        customer = new Customer(this, this);
        return customer;
    }
    
    public CustomerList getCustomerList(jdbcResultSet resultSet) {
        customerList = new CustomerList(this, this, resultSet);
        return customerList;
    }
    
    public CustomerEdit getCustomerEdit(int editType, jdbcResultSet resultSet) {
        customerEdit = new CustomerEdit(this, this, editType, resultSet);
        return customerEdit;
    }
    
    public Product getProduct() {
        product = new Product(this, this);
        return product;
    }
    
    public ProductList getProductList(jdbcResultSet resultSet) {
        productList = new ProductList(this, this, resultSet);
        return productList;
    }
    
    public Order getOrder() {
        order = new Order(this, this);
        return order;
    }
    
    public OrderList getOrderList(jdbcResultSet resultSet) {
        orderList = new OrderList(this, this, resultSet);
        return orderList;
    }
    
    public Login getLogin(int loginType) {
        login = new Login(this, this, loginType);
        return login;
    }
    
    public ChangePassword getChangePassword() {
        changePassword = new ChangePassword(this, this);
        return changePassword;
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
    }

    public void commandAction(Command command, Displayable displayable) {
        if (displayable == mainMenu) {
            mainMenu.fireCommand(command);
        } else
        if (displayable == customer) {
            customer.fireCommand(command);
        } else
        if (displayable == customerList) {
            customerList.fireCommand(command);
        } else
        if (displayable == customerEdit) {
            customerEdit.fireCommand(command);
        } else
        if (displayable == product) {
            product.fireCommand(command);
        } else
        if (displayable == productList) {
            productList.fireCommand(command);
        } else
        if (displayable == order) {
            order.fireCommand(command);
        } else
        if (displayable == orderList) {
            orderList.fireCommand(command);
        } else
        if (displayable == menu) {
            menu.fireCommand(command);
        } else
        if (displayable == login) {
            login.fireCommand(command);
        } else
        if (displayable == changePassword) {
            changePassword.fireCommand(command);
        } else
        if (displayable == login) {
            login.fireCommand(command);
        } else
        if (displayable == systemMessage) {
            systemMessage.fireCommand(command);
        }
    }
    
    public void destroyForm(Form form) {
        form = null;
    }
    
    public void closeApp() {
        Display.getDisplay(this).setCurrent(null);
        destroyApp(true);
        notifyDestroyed();        
    }
    
}
