package br.com.dreamsource.mobile.worders.order;

import br.com.dreamsource.mobile.jmesql.exceptions.SQLException;
import br.com.dreamsource.mobile.jmesql.jdbcResultSet;
import br.com.dreamsource.mobile.worders.WOrders;
import br.com.dreamsource.mobile.components.FormWOrders;
import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Image;

/**
 *
 * @author Elizeu Nogueira da Rosa Jr.
 * @version 0.1
 * @date 18.05.2007
 *
 */

public class OrderList  extends FormWOrders {
    
    private jdbcResultSet resultSet;
    
    private Command nextPageCommand;
    private Command previousPageCommand;
    private Command editCommand;
    private Command deleteCommand;
    private Command mainMenuCommand;
    private Command backCommand;
    
    private ChoiceGroup radioGroupLocated;
    private String[] radioGroupLocatedItems;
    private Image[] radioGroupImage;
    
    public OrderList(CommandListener listener, WOrders midlet, jdbcResultSet resultSet) {
        super(listener, midlet, "Lista de pedidos");
        this.resultSet = resultSet;
        this.loadResultList(false);
    }
    
    private void loadResultList(boolean previous) {
        radioGroupLocated.deleteAll();
        if (previous) {
            try {
                int count = 0;
                while (resultSet.previous()) {
                    count++;
                    radioGroupLocated.append(resultSet.getString(1), null);
                    if (count == 10) {
                        break;
                    }
                }
            } catch (SQLException sqlEx) {
                //TODO process exception
            }
        } else {
            try {
                while (resultSet.next()) {
                    radioGroupLocated.append(resultSet.getString(1), null);
                }
            } catch (SQLException sqlEx) {
                //TODO process exception
            }
        }
        
    }

    private ChoiceGroup getRadioGroupLocated() {
        if (radioGroupLocated == null) {
            
            radioGroupLocatedItems = new String[]{};
            radioGroupImage = new Image[]{null, null};
            
            radioGroupLocated = new ChoiceGroup("Resultados", Choice.EXCLUSIVE, 
                    radioGroupLocatedItems, radioGroupImage);
            radioGroupLocated.setSelectedFlags(new boolean[]{true, false});
            radioGroupLocated.setFitPolicy(Choice.TEXT_WRAP_ON);
        }
        return radioGroupLocated;
    }       
    
    protected void createComponents() {
        this.append(this.getRadioGroupLocated());
        this.addCommand(this.getDeleteCommand());
        this.addCommand(this.getEditCommand());
        this.addCommand(this.getPreviousPageCommand());
        this.addCommand(this.getNextPageCommand());
        this.addCommand(this.getBackCommand());
        this.addCommand(this.getMainMenuCommand());
    }

    public void fireCommand(Command command) {
        try {
            if (command == nextPageCommand) {
                if (! resultSet.isLast()) {
                    this.loadResultList(false);
                }
            } else
            if (command == previousPageCommand) {
                if (! resultSet.isFirst()) {
                    this.loadResultList(true);
                }
            } else
            if (command == editCommand) {
                //TODO enviar para a pgina de edio
            } else
            if (command == deleteCommand) {
                //TODO excluir registro
            } else
            if (command == backCommand) {
                this.sendToForm(midlet.getOrder());
                this.midlet.destroyForm(this);
            } else
            if (command == mainMenuCommand) {
                this.sendToForm(midlet.getMainMenu());
                this.midlet.destroyForm(this);
            }
            
        } catch (SQLException e) {
            //TODO process exception
        }
    }
    
}
